set terminal pngcairo enhanced
set xrange [0:2048]
set xlabel 'matrix size n'
set ylabel '% of peak-performance'

set xtics (32,128,256,512,768,1024,2048)
set xtics rotate by -45

set title 'Efficiency'
set output 'efficiency.png'
plot 'data.log' using 1:($3*100) w lp lt 1 lw 2 title 'my\_dgemm one core', '' using 1:($4*100) w lp lt 2 lw 2 title 'my\_dgemm all cores', 'blasdata.log' using 1:($3*100) w lp lt 3 lw 2 title 'blas\_dgemm one core', '' using 1:($4*100) w lp lt 4 lw 2 title 'blas\_dgemm all cores'
