#include "util.h"
// returns minimum of vector
float min(int n, float* v) {
    float min = v[0];
    for (int i=1; i<n; i++)
        if (v[i] < min)
            min = v[i];
    return min;
}

// returns maximum of vector
float max(int n, float* v) {
    float max = v[0];
    for (int i=1; i<n; i++)
        if (v[i] > max)
            max = v[i];
    return max;
}

// print matrix
void print(int m, int n, double* A, int lda) {
    for (int i=0; i<m; i++) {
        for (int j=0; j<n; j++) {
            printf("%e ", A[i + j * lda]);
        }
        printf("\n");
    }
}

// initmatrix
void initmatrix(int n, double a, double b, double* A, double* B) {
    //srand(time(0));
    for (int i=0; i<n*n; i++) {
        A[i] = (double) rand()/RAND_MAX * (b-a) + a;
        B[i] = (double) rand()/RAND_MAX * (b-a) + a;
    }
}


// 1-norm of matrix
double norm1(int n, double* A) {
    double nrm = 0e0;
    double sum;
    for (int j=0; j < n; j++) {
        sum = cblas_dasum(n,A+j*n,1);
        nrm = (sum > nrm) ? sum : nrm;
    }
    return nrm;
}

// calculates ||C-A*B||
double residual(int n, double* A, double* B, double* C) {
    cblas_dgemm(CblasColMajor,CblasNoTrans,CblasNoTrans,n,n,n,1e0,A,n,B,n,-1e0,C,n);

    return norm1(n, C);
}
